class Elem{
	int key;
	Elem next;
}

class Stack{
	Elem top;
	int size;
}

class Queue {
	Elem first;
	Elem last;
	int size;
}

public class Main {

	public static void main(String[] args) {
		System.out.println("PILA:");
		testPila();
		System.out.println("CODA:");
		testCoda();
	}
	
	static void enqueue (Queue q, int key) {
		Elem e = new Elem();
		e.key=key;
		if (q.last==null) {
			q.first=e;
			q.last=e;
		} else {
			(q.last).next=e;
			q.last=e;
		}
		q.size++;
	}
	
	static int dequeue (Queue q) {
		if (q.first==null) {
			System.out.println("ERRORE: coda vuota");
			return 0;
		}
		int key = (q.first).key;
		q.first=(q.first).next;
		if (q.first==null) {
			q.last=null;
		}
		q.size--;
		return key;
	}
	
	
	static void testPila() {
		/*
		  1. creare una pila vuota
		  2. aggiungere le chiavi 1, 5, 3, 8 in questo ordine
		  3. stampare la pila ottenuta
		  4. estrarre un elemento dalla pila
		  5. stampare di nuovo la pila
		 */
		
		//1
		Stack pippo = new Stack();
		//2
		push (pippo,1);
		push (pippo,5);
		push (pippo,3);
		push (pippo,8);
		//3
		stampaPila(pippo);
		//4 
		int estratto = pop(pippo);
		System.out.println("Ho estratto "+ estratto);
		//5
		stampaPila(pippo);
	}
	
	static void testCoda() {
		/*
		  1. creare una coda vuota
		  2. aggiungere le chiavi 1, 5, 3, 8 in questo ordine
		  3. stampare la coda ottenuta
		  4. estrarre un elemento dalla coda
		  5. stampare di nuovo la coda
		 */
		
		//1
		Queue pippo = new Queue();
		//2
		enqueue (pippo,1);
		enqueue (pippo,5);
		enqueue (pippo,3);
		enqueue (pippo,8);
		//3
		stampaCoda(pippo);
		//4 
		int estratto = dequeue(pippo);
		System.out.println("Ho estratto "+ estratto);
		//5
		stampaCoda(pippo);
	}
	
	
	static void push (Stack s, int key) {
		Elem e = new Elem();
		e.key=key;
		e.next=s.top;
		s.top=e;
		s.size++;
	}
	
	static int pop (Stack s) {
		if (s.top==null) {
			System.out.println("ERRORE: pila vuota");
			return 0;
		}
		int key = (s.top).key;
		s.top=(s.top).next;
		s.size--;
		return key;
	}
	
	static void stampaPila (Stack s) {
		if (s==null) {
			return;
		}
		Elem i = s.top;
		while (i!=null) {
			System.out.print(i.key);
			if (i.next!=null) {
				System.out.print("; ");
			}
			i = i.next;
		}
		System.out.println();
	}
	
	static void stampaCoda (Queue q) {
		if (q==null) {
			return;
		}
		Elem i = q.first;
		while (i!=null) {
			System.out.print(i.key);
			if (i.next!=null) {
				System.out.print("; ");
			}
			i = i.next;
		}
		System.out.println();
	}
	
	
	static void stampaPila2 (Stack s) {
		if (s==null) {
			return;
		}
		for (Elem i =s.top; i!=null; i=i.next) {
			System.out.print(i.key);
			if (i.next!=null) {
				System.out.print("; ");
			}
		}
		System.out.println();
	}

}
